<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>The ESP-AT MQTT library project: A simple wrapper library for the MQTT functionality in the esp-at stack.</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">The ESP-AT MQTT library project
   </div>
   <div id="projectbrief">A simple wrapper to the MQTT functionality found in the ESP-AT interpreter</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">A simple wrapper library for the MQTT functionality in the esp-at stack. </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>This library was developed to support the MQTT stack found in the ESP-AT interpreter. It forms a simple wrapper around the AT commands in order to make it easier to use, instead of sending AT commands over the serial port you can now use a simple C++ class with a well defined API to do the same. All the handling of the serial port is taken care of for you.</p>
<h1><a class="anchor" id="autotoc_md1"></a>
The AT_Class</h1>
<p>A simple AT handler class supports all the low level stuff towards the ESP-AT device. It will handle everything from the simple sending of data up to waiting for asynchronous responses as well as dealing with serial timeouts.</p>
<h1><a class="anchor" id="autotoc_md2"></a>
The EspATMQTT Class</h1>
<p>This is the cruncher of the library. It forms a well defined API and lets the user focus on developing his/hers application rather than having to deal with serial timeouts and other hardware releated bits and bobs.</p>
<h2><a class="anchor" id="autotoc_md3"></a>
Connections</h2>
<p>In its most simple form only three lines is necessary to connect to a MQTT server/broker.</p>
<div class="fragment"><div class="line">mqtt.begin();</div>
<div class="line">mqtt.userConfig(DEFAULT_LINK_ID, ESP_MQTT_SCHEME_MQTT_OVER_TCP, &quot;Challenger_RP2040_WiFi_BLE&quot;);</div>
<div class="line">mqtt.connect(DEFAULT_LINK_ID, &quot;192.168.0.151&quot;);</div>
</div><!-- fragment --><p>That is it. you can now make your subscriptions or start sending data as easy as 1-2-3.</p>
<h2><a class="anchor" id="autotoc_md4"></a>
Subscriptions</h2>
<p>Subscriptions are easily handled by subscribing to a topic and for every message that you receive you will receive a callback that can be used to handle the incoming data. A perfect way to handle control parameters and other run time relevant data.</p>
<div class="fragment"><div class="line">void sub_cb(char *topic, char *data) {</div>
<div class="line">  Serial.printf(&quot;Data incoming:. topic: &#39;%s&#39;, data &#39;%s&#39;\n&quot;, topic, data);</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line">  mqtt.subscribeTopic(sub_cb, DEFAULT_LINK_ID, &quot;messages/news&quot;);</div>
<div class="line">  mqtt.subscribeTopic(sub_cb, DEFAULT_LINK_ID, &quot;messages/bulletin&quot;);</div>
</div><!-- fragment --><h2><a class="anchor" id="autotoc_md5"></a>
Publish data</h2>
<p>And it is of course just as easy to send data. Two different methods can be used. If you only have small strings that need to be sent use the pubString() method. This method is however not so convenient if you have a little more data to send. In this case you can use the pubRaw() method. This method makes it much easier to publish larger json string or binary data.</p>
<div class="fragment"><div class="line">// Publish a short string to the server/broker</div>
<div class="line">mqtt.pubString(DEFAULT_LINK_ID, &quot;messages/log&quot;, &quot;Error 101 - Could not find the file !&quot;);</div>
<div class="line">mqtt.pubString(DEFAULT_LINK_ID, &quot;messages/data&quot;, &quot;{&quot;time&quot;:&quot;Thu Jul  7 09:30:37 2022&quot;\\,&quot;temp&quot;:&quot;22.33&quot;,&quot;humidity&quot;:&quot;78.30%&quot;}&quot;);</div>
</div><!-- fragment --><p>Notice the double escaped comma sign in the json formated string above. This is required when using the pubString method but not when using the pubRaw() method.</p>
<p>Here's a simple example on how to create and send a json formated response using the pubRaw() method.</p>
<div class="fragment"><div class="line">StaticJsonDocument&lt;1024&gt; doc;</div>
<div class="line"> </div>
<div class="line">char *time;</div>
<div class="line">mqtt.getNTPTime(&amp;time);</div>
<div class="line"> </div>
<div class="line">doc[&quot;time&quot;] = time;</div>
<div class="line">doc[&quot;temp&quot;] = String(random(2200, 2300) / 100.0);</div>
<div class="line">doc[&quot;humidity&quot;] = String(random(780, 790) / 10.0) + &quot;%&quot;;</div>
<div class="line"> </div>
<div class="line">char output[1024];</div>
<div class="line">serializeJson(doc, output);</div>
<div class="line">mqtt.pubRaw(DEFAULT_LINK_ID, &quot;messages/data&quot;, output);</div>
</div><!-- fragment --><h1><a class="anchor" id="autotoc_md6"></a>
Security</h1>
<p>MQTT relies on the TCP transport protocol. By default, TCP connections do not use an encrypted communication. To encrypt the whole MQTT communication, many MQTT brokers (such as HiveMQ and Mosquitto) allow use of TLS instead of plain TCP. If you use the username and password fields of the MQTT CONNECT packet for authentication and authorization mechanisms, you should strongly consider using TLS.</p>
<p>Port 8883 is standardized for a secured MQTT connection. The standardized name at IANA is “secure-mqtt”. Port 8883 is exclusively reserved for MQTT over TLS.</p>
<p>The ESP-AT MQTT client also supports the use of TLS to protect your data and this wrapper of course also supports this. A number of conenction methods and certificate validation schemes can be used (See <a class="el" href="EspATMQTT_8h.html#a358bb63a2641aef322dde4dfa36c69e4" title="MQTT configuration schemes.">mqtt_scheme_e</a>) with this implementation.</p>
<p>Selecting a connection scheme is a simple oneliner: </p><div class="fragment"><div class="line">mqtt.userConfig(DEFAULT_LINK_ID, ESP_MQTT_SCHEME_MQTT_OVER_TLS_VSCPCC, &quot;Challenger_RP2040_WiFi_BLE&quot;);</div>
</div><!-- fragment --><p>Validation of certificates requires that the system can tell the data and time and the library implements methods for enabling an ESP-AT internal NTP client that automatically connects and get the current date and time.</p>
<p>Enabling the NTP client is also extremely simple, simply enter: </p><div class="fragment"><div class="line">mqtt.enableNTPTime(true, ntp_time_received, 2, &quot;us.pool.ntp.org&quot;);</div>
</div><!-- fragment --><p>When the client has acquired a valid date and time the <code>ntp_time_received</code> function will be called in which you can go ahead and connect to your secure MQTT server/broker.</p>
<p>Certificate, key and CA can be uploaded to the device to support any IoT cloud vendor. We've tested the library and ESP-AT fw with Amazon AWS, Microsoft Azure and a bunch of local test servers using different security schemes.</p>
<h1><a class="anchor" id="autotoc_md7"></a>
License</h1>
<p>Copyright (c) 2022 iLabs - Pontus Oldberg</p>
<p>Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:</p>
<p>The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.</p>
<p>THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. </p>
</div></div><!-- PageDoc -->
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
